<id>
Fix Board Dupes
</id>

<version>
0.1
</version>

<mod info>
Description:
Fixes duplication of boards in forum.master. This mod adds a notice in ManageBoards that there are duplicates boards, creates a screen so select the dupes to be removed.

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.

cgi-bin/yabb2/Admin/ModList.pm (ASCII)
cgi-bin/yabb2/Admin/AdminSubList.pm (ASCII)
cgi-bin/yabb2/Admin/ManageBoards.pm (ASCII)
cgi-bin/yabb2/Languages/English/Admin.lng (ASCII)

</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $fixbrddupes = q~Fix Board Dupes|Dandello|Fixes duplication of boards in forum.master.|0.1|02/02/2015~;
    push @installed_mods, $fixbrddupes;
</add before>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
$director{'fixboarddupes'} = 'ManageBoards.pm&FixBoardDupes';
$director{'fixdupes'} = 'ManageBoards.pm&FixDupes';

</add before>

<edit file>
Admin/ManageBoards.pm
</edit file>

<search for>
        $act2        = 'addboard';
        $action_area = 'manageboards';
</search for>

<add after>
        ## find bad boards
        my @dupedbrds = ();
        my @mylist = ();
        while( ( $key, $value ) = each %cat ) {
            @mylist = split /,/xsm, $value;
            push @dupedbrds, @mylist;
        }
        while( ( $key, $value ) = each %subboard ) {
            @mylist = split /[|]/xsm, $value;
            push @dupedbrds, @mylist;
        }
        my %dup_counts;
        for (@dupedbrds) { $dup_counts{$_}++ };
        my @chkbrds = grep { $dup_counts{$_} > 1 } keys %dup_counts;
        @chkbrds = sort(@chkbrds);
        if (@chkbrds) {
            $managedescr .= qq~<br />$admin_txt{'dupbrd'} @chkbrds<br />$admin_txt{'dupbrdlnk'}~;
        }
</add after>

<search for>
1;
</search for>

<add before>

sub FixBoardDupes {
    is_admin_or_gmod();
    get_forum_master();
    my @dupedbrds = ();
    my @mylist = ();
    my @catbrds = ();
    my @subbrds = ();
    while( ( $key, $value ) = each %cat ) {
        @mylist = split /,/xsm, $value;
        push @dupedbrds, @mylist;
    }
    while( ( $key, $value ) = each %subboard ) {
        @mylist = split /[|]/xsm, $value;
        push @dupedbrds, @mylist;
    }
    my %dup_counts;
    for (@dupedbrds) { $dup_counts{$_}++ };
    my @chkbrds = grep { $dup_counts{$_} > 1 } keys %dup_counts;
    if (@chkbrds) {
        while( ( $key, $value ) = each %cat ) {
            @mylist = split /,/xsm, $value;
            for my $x (@mylist) {
                for my $y (@chkbrds) {
                    if ( $x eq $y ) {
                        push @catbrds, qq~$x|c|$key~;
                    }
                }
            }
        }
        while( ( $key, $value ) = each %subboard ) {
            @mylist = split /[|]/xsm, $value;
            for my $x (@mylist) {
                for my $y (@chkbrds) {
                    if ( $x eq $y ) {
                        push @catbrds, qq~$x|s|$key~;
                    }
                }
            }
        }
    }
    $dupedlist = qq~<br /><span style="font-size:125%">$admin_txt{'fixinstruct'}</span>~;
    @catbrds = sort(@catbrds);
    $mynum = 0;
    for (@catbrds) {
        my( $dpfile, $tp, $mydupcat ) = split /[|]/xsm, $_;
        if ( $tp eq 'c') {
            $dupedlist .= qq~<br /><input type="checkbox" name="$mynum|$_" value="1" /> $admin_txt{'58'} $dpfile $admin_txt{'incat'} $mydupcat~;
        }
        else {
            $dupedlist .= qq~<br /><input type="checkbox" name="$mynum|$_" value="1" /> $admin_txt{'subbrd'} $dpfile $admin_txt{'inbrd'} $mydupcat~;
        }
        $mynum++;
    }
    $yymain .= qq~
    <form action="$adminurl?action=fixdupes" method="post" accept-charset="$yymycharset">
    <table class="bordercolor border-space pad-cell">
        <tr>
            <td class="titlebg">$admin_img{'cat_img'}&nbsp;<b>$admin_txt{'fixdupbrd'}</b></td>
        </tr><tr>
            <td class="windowbg">
                 $dupedlist
            </td>
        </tr><tr>
            <td class="titlebg center">
                <input type="submit" value="$admin_txt{'fixdupbrd'}" class="button" />
            </td>
        </tr>
    </table>
    </form>
~;
    $yytitle     = qq~$admin_txt{'fixdupbrd'}~;
    $action_area = 'manageboards';
    AdminTemplate();
    return;
}

sub FixDupes {
    is_admin_or_gmod();
    get_forum_master();
    @torem = ();
    $i = 0;
    while ( $_ = each %FORM ) {
        if ( $FORM{$_} ) {
            my( $num, $dpfile, $tp, $mydupcat ) = split /[|]/xsm, $_;
            push @torem, qq~$dpfile|$tp|$mydupcat~;
        }
    }
    my %hash;
    my @del = ();
    my $i = 0;
    $hash{$_}++ foreach (@torem);
    for (keys %hash) {
        ( $dpfile, $tp, $mydupcat ) = split /[|]/xsm, $_;
        if ( $tp eq 'c' ) {
            @dupcat = split /,/xsm, $cat{$mydupcat};
            $i = 0;
            $i++ until $dupcat[$i] eq $dpfile;
            splice(@dupcat, $i, 1);
            $cat{$mydupcat} = join q{,}, @dupcat;
            push @del, $dpfile;
        }
        else {
            @dupcat = split /[|]/xsm, $subboard{$mydupcat};
            $i = 0;
            $i++ until $dupcat[$i] eq $dpfile;
            splice(@dupcat, $i, 1);
            $subboard{$mydupcat} = join q{,}, @dupcat;
            push @del, $dpfile;
        }
    }

    Write_ForumMaster();
    $yymain .= qq~Duplicate Boards removed<br />@del<br /><a href="$adminurl?action=manageboards">$admin_txt{'51'}</a>~;
    $yytitle     = qq~$admin_txt{'fixdupbrd'}~;
    $action_area = 'manageboards';
    AdminTemplate();
    return;
}

</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$admin_txt{'dupbrd'} = '<span class="important"><b>Warning</b>: There are duplicate Boards: </span>';
$admin_txt{'dupbrdlnk'} = qq~<span class="important"><a href="$boardurl/AdminIndex.$yyaext?action=fixboarddupes">Fix duplicate boards</a></span>~;
$admin_txt{'fixdupbrd'} = 'Fix Duplicates';
$admin_txt{'subbrd'} = 'Sub-Board';
$admin_txt{'inbrd'} = 'in Board';
$admin_txt{'incat'} = 'in Category';
$admin_txt{'fixinstruct'} = 'Select the <b>incorrect</b> board(s). You may need to reorganize the position of boards in their categories/boards when finished.<br /><span class="important">Be very careful with your selections to make sure you do not remove the copy of the board you want to keep.</span>';

</add before>
